#include "stdafx.h"
#include "TempLocale.h"


#ifndef UNDER_CE

CCrtLocaleSwitch::CCrtLocaleSwitch(LCID lcNew/*=0*/)
{
	//set the restoration locale
	loadLocaleId( GetThreadLocale(), _strLocale );
	if( lcNew )
		setLocale(lcNew);
}

LPCTSTR CCrtLocaleSwitch::loadLocaleId(LCID lcid, _bstr_t& bstrRetBuf)
{
	TCHAR arcBuf[128];
	memset(arcBuf, 0, sizeof(arcBuf));
	
	//We should check the return code, but skipped for brevity...
	//Loading the English name fo the locale
	GetLocaleInfo( lcid, LOCALE_SENGLANGUAGE, arcBuf, 127);
	bstrRetBuf = arcBuf;
	memset(arcBuf, 0, sizeof(arcBuf));
	//Loading the English name for the country/region
	GetLocaleInfo( lcid, LOCALE_SENGCOUNTRY, arcBuf, 127);
	if( *arcBuf )
	{
		bstrRetBuf += TEXT("_");
		bstrRetBuf += arcBuf;
	}
	//Loading the code page
	memset(arcBuf, 0, sizeof(arcBuf));
	if( (GetLocaleInfo( lcid, LOCALE_IDEFAULTANSICODEPAGE, arcBuf, 127)
		|| GetLocaleInfo( lcid, LOCALE_IDEFAULTCODEPAGE, arcBuf, 127))
		&&  *arcBuf 
	){
		bstrRetBuf += TEXT(".");
		bstrRetBuf += arcBuf;
	}
	return bstrRetBuf;
}

bool CCrtLocaleSwitch::setLocale(LCID lcNew)
{
	_bstr_t bstrLocale;
	loadLocaleId(lcNew, bstrLocale);
	return _tsetlocale(LC_ALL, bstrLocale) ? true : false;
}
#endif